#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
using namespace std;

#include "conffile.h"

Config::Config() :
    rating(3.0),
    shouldUpdateRating(false)
{
    ifstream* f = new ifstream;
    char* home = getenv("HOME");
    
    if (home != NULL)
    {
	string homeStr = home;
	f->open((home + (string)"/.kuklomenosrc").c_str());
    }
    if (!f->is_open())
	f->open("./kuklomenosrc.txt");

    if (f->is_open())
    {
	int ret;
	char line[50];

	f->getline(line, 50);
	ret = sscanf(line, "rating: %lf", &rating);
	if (ret != 1)
	{
	    fprintf(stderr, "Bad config file.\n");
	}
    }
}

void Config::write()
{
    ofstream* f = new ofstream;
    char* home = getenv("HOME");
    
    if (home != NULL)
    {
	string homeStr = home;
	f->open((home + (string)"/.kuklomenosrc").c_str());
    }
    if (!f->is_open())
	f->open("./kuklomenosrc.txt");

    if (!f->is_open())
	fprintf(stderr, "Couldn't write config file.\n");
    else
    {
	int n;
	char line[50];

	n = snprintf(line, 50, "rating: %.2lf\n", rating);
	f->write(line, n);
	f->flush();
    }
}

Config config;
