#include <cmath>

#include "coords.h"

RelPolarCoord::RelPolarCoord(const RelCartCoord& c)
{
    dist = sqrt(c.dx*c.dx + c.dy*c.dy);
    angle = atan2(-c.dx, c.dy)/(PI/2);
}

RelCartCoord::RelCartCoord(const RelPolarCoord &rp)
{
    dx = -rp.dist*sin(rp.angle * (PI/2));
    dy = rp.dist*cos(rp.angle * (PI/2));
}

RelCartCoord RelCartCoord::rotated(float angle) const
{
    if (angle == 0)
	return *this;

    RelPolarCoord p(*this);
    p.angle += angle;
    return p;
}
