#include <iostream>
#include <fstream>
#include <string>
using namespace std;

#include <SDL/SDL_gfxPrimitives.h>

#include "data.h"

char fontSmall[3328];
char fontBig[10240];

// TODO: compile-time setting of global path
const int numDataPaths = 4;
const string dataPaths[numDataPaths] = { "./", "/usr/share/kuklomenos/",
    "/usr/local/share/kuklomenos/", "/usr/share/games/kuklomenos/"};
ifstream* openDataFile(string relPath)
{
    ifstream* f = new ifstream;
    for (int i=0; i < numDataPaths; i++)
    {
	f->open((dataPaths[i]+relPath).c_str(), ios::binary);
	if (f->is_open())
	    return f;
	else
	    continue;
    }
    return f;
}

const char* findDataPath(string relPath)
{
    ifstream* f = new ifstream;
    for (int i=0; i < numDataPaths; i++)
    {
	const char* absPath = (dataPaths[i] + relPath).c_str();
	f->open(absPath, ios::binary);
	if (f->is_open())
	    return absPath;
	else
	    continue;
    }
    return NULL;
}

bool initFont()
{
    ifstream* f = openDataFile("7x13.fnt");
    ifstream* f2 = openDataFile("10x20.fnt");

    if (!f->is_open())
	return false;

    f->read(fontSmall, 3328);
    f2->read(fontBig, 10240);

    delete f;

    return true;
}
