#include <algorithm>

#include "geom.h"
#include "gfx.h"
#include "coords.h"

ScreenGeom::ScreenGeom(int iwidth, int iheight) :
    width(iwidth), height(iheight),
    centre(iwidth/2, iheight/2),
    rad(std::min(iwidth,iheight)/2 - 20)
{
    // info = centre + [(rad+[room for 3 lines]) out at -pi/6 from vertical]
    info.x = centre.x + (rad+15*3)/2;
    info.y = centre.y - (int)((rad+15*3)*0.866);
}

ScreenGeom screenGeom;

int ARENA_RAD = 220;

float ZOOMDIST_MAX = (float)((ARENA_RAD/2));

float AIM_MIN = 20.0;
float ZOOM_MIN = 0.0;
float AIM_MAX = ZOOMDIST_MAX;

CartCoord ARENA_CENTRE(0,0);
